--[[
Name: TreatOrTreat
Revision: $Revision: 5 $
Author(s): falconindy
Description: Warnings for targets and recipient rogues of Tricks of the Trade.
Inspired by: SimpleMD and Misdrection Helper
]]

local ver, rev = "1.0", tonumber(("$Revision: 5 $"):match("%d+"))
local addonID = "TrickOrTreat-" .. ver .. " r" .. rev 
local pName = UnitName("player")
local threat_low = "|cff00ff00%d%|r"	--green
local threat_med = "|cffffff00%d%|r"	--yellow
local threat_high = "|cffff0000%d%|r"	--red
local ClassColor = {
	["DEATHKNIGHT"] = "|cffc41f3b",
	["DRUID"] = "|cffff7d0a",
	["HUNTER"] = "|cffabd473",
	["MAGE"] = "|cff69ccf0",
	["PALADIN"] = "|cfff58cba",
	["PRIEST"] = "|cffffffff",
	["ROGUE"] = "|cfffff569",
	["SHAMAN"] = "|cff2459ff",
	["WARLOCK"] = "|cff9482c9",
	["WARRIOR"] = "|cffc79c6e",
}

--Addon Declaration
ToT = LibStub("AceAddon-3.0"):NewAddon("TreatOrTreat", "AceEvent-3.0", "AceConsole-3.0", "LibSink-2.0")

--Register Event on Enable
function ToT:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	self:SetSinkStorage({ ["sink20OutputSink"] = "RaidWarning" })

	dmgCounter = 0
	parse_dmg = false
--	last_tricked = nil
end

--Unregister Event on Disable
function ToT:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

--57933 Tricks on the target
--57934 Tricks on the rogue (primer)
function ToT:COMBAT_LOG_EVENT_UNFILTERED(event, _, subevent, _,sourceName, _, _, destName, _, spellID, spellName, _, arg12)
	if spellID == 57933 then
		if subevent == "SPELL_AURA_APPLIED" and sourceName == pName then
			local themessage = "Trick or Treat!"
			if UnitExists("target") then
				local isTanking,_,threatpct,_,threatvalue = UnitDetailedThreatSituation(destName, "target");
				if threatvalue == nil then threatvalue, threatpct = 0, 0 end
				threatpct = threatpct * 1.1
				local rawtotank = threatvalue * (100 / threatpct - 1)
				if not isTanking and (threatpct > 50 or rawtotank <= 20000) then
					threatpct = tostring(math.floor(threatpct).."%")
					themessage = themessage.." Misdirecting "..UnitName("target").." (You're @"..threatpct.." threat)"
				end
			end
			SendChatMessage(themessage, "WHISPER", nil, destName)
		elseif subevent == "SPELL_AURA_APPLIED" and destName == pName then
			self:Pour(sourceName.." tricked you!")
			PlaySoundFile("Interface\\AddOns\\TrickOrTreat\\sounds\\alert.mp3")
		end
	end
	if spellID == 57934 then
		if subevent == "SPELL_CAST_SUCCESS" and sourceName == pName then
--			last_tricked = destName
			parse_dmg = true
			self:Pour("|cffff6600[Trick or Treat] "..ClassColor[select(2, UnitClass(destName))]..destName.."|r")
		end
	end
	if spellID == 59628 then
		if subevent == "SPELL_AURA_REMOVED" and destName == pName then
			self:Print(dmgCounter.." damage dealt over tricks duration.")
--			SendChatMessage("Tricks out! "..dmgCounter.." damage dealt over duration.", "WHISPER", nil, last_tricked)
			parse_dmg = false
			dmgCounter = 0
		end
	end

	if parse_dmg then
		if (subevent == "SPELL_DAMAGE" or subevent == "SPELL_PERIODIC_DAMAGE") and sourceName == pName then
			dmgCounter = dmgCounter + arg12 - arg13 --arg12 is ability/spell/dot damage, arg13 is overkill
		elseif subevent == "SWING_DAMAGE" and sourceName == pName then
			dmgCounter = dmgCounter + arg9 - arg10 --arg9 is swing damage, arg10 is overkill
		end
	end

end
